//
// $Id: ipfw-allowonly.c,v 1.3 2001/11/16 02:54:21 mavetju Exp $
//

//
// Draw the graphics
//
// Draw only the allow-fields
//

#include <gtk/gtk.h>
#include <stdio.h>
#include "ipfw-graph.h"


//
// Draw the graphs
//
static long piles[MAXSTORED];

// draw the coloured piles on top of each other
static void draw_pile(DATA_TYPE data) {
    int x,y;

    for (x=MAXSTORED-xsize;x<MAXSTORED;x++) {
	y=piles[x];
	gdk_draw_line(drawtable[current_page].pixmap,data.gc,
	    x-(MAXSTORED-xsize),
	    ysize_drawing-(ysize_drawing*(y))/maxyvalues[x],
	    x-(MAXSTORED-xsize),
	    ysize_drawing-(ysize_drawing*(y+data.table[x]))/maxyvalues[x]);

	piles[x]+=data.table[x];
    }

}

// draw a realtime graph
static void draw_line(DATA_TYPE data) {
    int x;

    for (x=MAXSTORED-xsize;x<MAXSTORED;x++)
	gdk_draw_line(bytes_pixmap,data.gc,
	    x-1-(MAXSTORED-xsize),
	    ysize_bytes-(ysize_bytes*data.table[x-1])/maxyvalue,
	    x-(MAXSTORED-xsize),
	    ysize_bytes-(ysize_bytes*data.table[x  ])/maxyvalue);
}


void allowonly_bytes(void) {
    draw_line(data_bytes);
}

void allowonly_drawing(void) {
    int i;

    if (drawtable[current_page].pixmap==NULL)
	return;
    memset(piles,0,MAXSTORED*sizeof(long));
    for (i=0;i<data_size;i++)
	if (data[i].allow)
	    draw_pile(data[i]);
}

void allowonly_stats(void) {
    char c[100];
    char m[100];
    char s[100];

    if (data_bytes.table[MAXSTORED-1]>9999999)
	sprintf(c,"%1.3f Mbps",data_bytes.table[MAXSTORED-1]/1000000.0);
    else if (data_bytes.table[MAXSTORED-1]>9999)
	sprintf(c,"%1.3f kbps",data_bytes.table[MAXSTORED-1]/1000.0);
    else
	sprintf(c,"%ld bps",data_bytes.table[MAXSTORED-1]);

    if (maxyvalue>9999999)
	sprintf(m,"%1.3f Mbps",maxyvalue/1000000.0);
    else if (maxyvalue>9999)
	sprintf(m,"%1.3f kbps",maxyvalue/1000.0);
    else
	sprintf(m,"%ld bps",maxyvalue);
    sprintf(s,"current %s  max %s",c,m);

    gtk_label_set_text((GtkLabel *)text_area,s);
}

